diff --git a/.ci/update_build_cache.sh b/.ci/update_build_cache.sh
index 04cb514f234bed16ad6426e4cd94599b8268db67..bac589990735aeea413306a374d919950823befc 100755
--- a/.ci/update_build_cache.sh
+++ b/.ci/update_build_cache.sh
@@ -35,7 +35,7 @@ source "${SOURCE_DIR}/commons.sh"
 # update script inside the container
 set +e
 # Arugments needed once we switch to singularity3: --writable-tmpfs
-sudo -Eu spack singularity exec\
+sudo -E singularity exec\
     -B "${BUILD_CACHE_OUTSIDE}:${BUILD_CACHE_INSIDE}:rw"\
     "${IMAGE_NAME}" \
-    /opt/spack_install_scripts/update_build_cache_in_container.sh -q || exit 0
+    sudo -Eu spack /opt/spack_install_scripts/update_build_cache_in_container.sh -q || exit 0
diff --git a/.ci/update_build_cache_in_container.sh b/.ci/update_build_cache_in_container.sh
index 38a4e421290f2239839ec54c605e35500c792e33..2371d59f4dee9dd088ac1a9a49916c5b66286b20 100755
--- a/.ci/update_build_cache_in_container.sh
+++ b/.ci/update_build_cache_in_container.sh
@@ -82,6 +82,9 @@ if (( quiet == 1 )); then
     args_progress=""
 fi
 
+# find requires current working directory to be readable by spack user
+cd ${MY_SPACK_FOLDER}
+
 get_hashes_to_store \
     | parallel -r ${args_progress} -j$(nproc) \
         tar Pcfz "${destination_folder}/{}.tar.gz" \"\$\(spack location -i /{}\)\"